function CopyTable(table)
	if not table then LOG([[Table doesn't exist]]) end
--	local newTable = {}
	local newTable = newtablesize(GetN(table))
	for key, value in table do
		if type(value) == "table" then
			newTable[key] = CopyTable(value)
		else
			newTable[key] = value
		end
	end
	return newTable
end

function GetN(table)
	local count = 0
	for key, value in table do
		count = count + 1
	end
	return count
end


function FullLookup(table, variableName)
	local lastPos = 1
	while 1 do
		local curPos = strfind(variableName, "%.", lastPos)
		if not curPos then
			local var = strsub(variableName, lastPos)
			local num = tonumber(var)
			if num then
				var = num
			end
			return table[var]
		end

		local var = strsub(variableName, lastPos, curPos - 1)
		local num = tonumber(var)
		if num then
			var = num
		end
		lastPos = curPos + 1
		table = table[var]
		if not table then
			return nil
		end
	end
end


function DirProcessFiles(path, wildcard, func)
	if type(func) ~= "function" then
		return
	end

	path = path->gsub("/", "\\")
	if path->sub(path->len()) ~= '\\' then
		path = path .. "\\"
	end

	local handle = FileFind.First(path .. wildcard)

	while 1 do
		local fileName = handle->GetFileName()
		local isDirectory = handle->IsDirectory()
		func(path, fileName)
		if not handle->Next() then
			break
		end
	end

	handle->Close()
end


function DirProcessFilesRecursive(path, func, ext)
	if ext then
		ext = ext->lower()
	end

	if type(func) ~= "function" then
		return
	end

	path = path->gsub("/", "\\")
	if path->sub(path->len()) ~= '\\' then
		path = path .. "\\"
	end

	function ReadDirectory(path)
		local handle = FileFind.First(path .. "*.*")

		while handle do
			local fileName = handle->GetFileName()
			local isDirectory = handle->IsDirectory()
			if isDirectory then
				if fileName ~= "." and fileName ~= ".." then
					ReadDirectory(path .. fileName .. "\\")
				end
			else
				if %ext then
					local dotPos, endPos, foundExt = fileName->find("%.(%w*)$")
					if foundExt then
						foundExt = foundExt->lower()
						if %ext == foundExt then
							%func(path, fileName)
						end
					end
				else
					%func(path, fileName)
				end
			end
			if not handle->Next() then
				break
			end
		end

		handle->Close()
	end

	ReadDirectory(path)
end
